<?php
/**
 * This file is here to help you generating your config file needed to use the Phonekey API by follow the directions above "What you have to set up".
 * It needs to be executed (with php >=5.3 with CURL and Json extensions) and it will create the config file.
 * You will also need an Internet connection to allow this script to retrieve the webservice public key at the address http://webservice.phonekey.eu/webservice/serverpublickey
 * @Version 0.1
 */

// #######################
// What you have to set up
// #######################

// The path to your private key file. You can generate one by following the quick start guide 
$yourPrivateFile = "private.pem";
// Put your API key here
$yourAPIkey = "a94f6r2j1k7w9qmzp4d5f1ry56exbn";
// The name to give to the output file
$theOutputFile = "config_file.conf";

// ##############################
// You don't have to modify below
// ##############################

// Verifying that the Client API is set
if($yourAPIkey === "")
	die("The client API is not set");

// Getting the server public key from the webservice : make sure your can reach it
// We need CURL to retrieve the server public key
if(!extension_loaded("curl"))
	die("Curl extension not loaded");
$ch = curl_init("http://webservice.phonekey.eu/webservice/serverpublickey");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_USERAGENT, "Phonekey conf helper v0.1a");
$public = curl_exec($ch);
curl_close($ch);

// If there was a problem retrieving the webservice public key
if($public === false)
	die("Error while retrieving webservice public key");

// Loading of your private key
if(($f = @fopen($yourPrivateFile, "r")) === false)
	die("Unable to load the private key from file : ".$yourPrivateFile);
$private = fread($f, filesize($yourPrivateFile));
if(openssl_pkey_get_private($private) === false){
	fclose($f);
	die("Unable to load the private key : bad format (must be PEM)");
}

// Building json
$json = json_encode(array("api_key" => $yourAPIkey,
		"private_key" => $private,
		"remote_host_address" => "webservice.phonekey.eu",
		"remote_host_port" => 80,
		"remote_host_public_key" => $public));

// Writing in the file
if(($f2 = fopen($theOutputFile, "w")) !== false){
	fputs($f2, $json);
	fclose($f2);
}

// Outputing the result
echo $json;